/* SofChat (Web Chat program SHM version)      */
/* Copyright(c) 1996-2000 Y.YONEYAMA           */
/*                                             */
/* code.c                                      */

#include <stdlib.h>
#include <time.h>
#ifdef WIN32
#include "win32/win32.h"
#endif /* WIN32 */
#include "code.h"

char *pkey = PASSWORD;

static int getpkey(i)
int i;
{
  return((pkey[i%strlen(pkey)] - 0x20)&0x1f);
}

void encode(dst, src)
char *dst;
char *src;
{
  int i, m, rkey;

  if(!((*src == '@') &&
      ((*(src+1) == '*') || (*(src+1) == '$') || (*(src+1) == '['))))
  {
    int ver = 1;
    if (*(src+1) == '*') ver = 0;
    *(dst++) = '@';
    *(dst++) = '['; /* ver2 */
    srand(time(0));
    rkey = rand()&0x0f;
    *(dst++) = 'A' + rkey; /* A-P */
    m = strlen(src);
    for(i=0;i<m;i++)
    {
      unsigned int d; /* 11bit */
      unsigned int r = rand()&0x07; /* 3bit */
      d = (((src[i]&0x7f)+getpkey(rkey+i))<<3) | r;
      *(dst++) = 0x40 | ((d>>6)&0x3f);
      *(dst++) = 0x40 | ((d&0x3f)>>ver);
    }
    *dst = '\0';
  }
  else
  {
    strcpy(dst, src);
  }
}

void decode(dst, src)
char *dst;
char *src;
{
  int i;
  if(*src == '@' &&
     ((*(src+1) == '*') || (*(src+1) == '$') || (*(src+1) == '[')))
  {
    int rkey;
    int ver = 1;
    if (*(src+1) == '*') ver = 0;
    src += 2;
    rkey = *(src++) - 'A';
    for(i=0;i<strlen(src);i+=2)
    {
      unsigned int d;
      d = ((src[i]&0x3f)<<6)|((src[i+1]&(0x3f>>ver))<<ver);
      d = (d>>3) - getpkey(rkey+i/2);
      *(dst++) = (d&0x7f);
    }
    *dst = '\0';
  }
  else
  {
    strcpy(dst, src);
  }
}

